// Include headers from OS
#include "final.h"

int hasBalls = 0;
double MASTER_START;
double GO_FOR_GEAR_START;
double GO_FOR_BING_BONG_START;
double MOVE_TIMEOUT_START;
#define  MOVE_TIMEOUT 5000

int ABANDON_GEARBOX;
int ABANDON_BING_BONG;

#define PROXIMITY_TO_DESIRED_POSITION 300
#define PROXIMITY_TO_GEAR_BOX 350
#define BACKWARD_SPEED 150
#define BACKWARD_HEADING_ERROR_TO_VEL_DIFF_FACTOR 1.5   //was 1.5 
#define AFTER_MINING_GO_BACK_FOR 500 //milliseconds
#define SPEED_AT_GEAR -50 //was -80
#define WHEN_DUMP_MOVE_TO_OR_FOR 1000
#define MINING_SERVO 0
#define DUMPING_SERVO 1
#define DUMPING_SERVO_OPEN 200
#define DUMPING_SERVO_CLOSED 400
#define AFTER_DUMPING_GO_BACK_FOR 500
#define DUMPING_PERIOD 2500

#define BING_BONG_TIMEOUT 6000
#define GEARBOX_TIMEOUT 5000
#define GEARBOX_TIMEOUT_2 8000

#define SERVO_DEFAULT 450
#define SERVO_MINING_MAX 450
#define SERVO_MINING_MIN 200
#define SERVO_PAUSE_WHILE_LEVER_DOWN 325  //Was 300
#define SERVO_PAUSE_WHILE_LEVER_DOWN 325  //Was 300
#define SERVO_PAUSE_BETWEEN 300 //Was 300
#define DUMP_AFTER_HOW_MANY_ROUNDS 2

int SPIN_MOTOR_SPEED;
int home[3];

// usetup is called during the calibration period. 
int usetup (void) {
	robot_id = 18;
	//pause(500);
	//gyro_init (GYRO_PORT, LSB_US_PER_DEG, 500L);
    return 0;
	
}

// Entry point to contestant code.
int umain (void) {
	
	/*servo_set_pos(MINING_SERVO,SERVO_DEFAULT);
	pause(1000);
	for (int i = 0; i < 5; ++i){
		servo_set_pos(MINING_SERVO,SERVO_MINING_MAX);
		pause(SERVO_PAUSE_BETWEEN);
		servo_set_pos(MINING_SERVO,SERVO_MINING_MIN);
		pause(SERVO_PAUSE_WHILE_LEVER_DOWN);
		}*/
	//create_thread(&update_variables, STACK_DEFAULT,0,"pid_thread");
	
	init_centers(); //init the center points
	init_gear_boxes(); //initializing gear_boxes values 
	init_bing_bong_balls(); //init the position of the ping pong balls
	setupSides();
	servo_set_pos(MINING_SERVO,SERVO_DEFAULT);
	servo_set_pos(DUMPING_SERVO,DUMPING_SERVO_CLOSED);
	updateRobot();
	MASTER_START = get_time();
	
	if (robot.x < 0){
		if (get_time() - MASTER_START < 10000){moveToRegion(5);}
		if (get_time() - MASTER_START < 10000){moveToRegion(1);}
		if (get_time() - MASTER_START < 10000){moveToRegion(3);}
	}
	else {
		if (get_time() - MASTER_START < 10000){moveToRegion(2);}
		if (get_time() - MASTER_START < 10000){moveToRegion(4);}
		if (get_time() - MASTER_START < 10000){moveToRegion(0);}
	}
	
	mockNumberTwo();
	
	return 0;
	
}

/*
int update_variables(void){

	
	while (1) {
		
	}
	
}
*/

void moveFwd(int time){
	leftMotor(LM_FWD_SPEED);
	rightMotor(RM_FWD_SPEED);
	
	pause(time);
	
	motorsStop();
}
	


void turnHeadToHeading(double headingtTH, int speed){ //takes heading between 0 and 360
	

	/*
	if (REVERSE == 1){
			if (headingtTH < 180){
				headingtTH += 180;}
			if (headingtTH > 180){
				headingtTH -= 180;}
			}
	*/
	
	double error;
	
	int newLeftMotorVel;
	int newRightMotorVel;
	
	//printf("\nSTART TURNING TO HEADING: %.2f\n", headingtTH);
	getHeading();
	while (fixHeadingProximity(robotHeading,headingtTH) > PROXIMITY_TO_HEADING){
		
		updateRobot();
		error = headingtTH - robotHeading;
		
		//fix error between -179.99 and 180
		if (error > 180){
			error -= 360;}
		if (error <= -180){
			error += 360;}	
		
		//Fix motor vels to ints between defined min and max rotation speeds...
		newLeftMotorVel = -calculateTurnMotorVelFromError(error);
		newRightMotorVel = calculateTurnMotorVelFromError(error);
		
		//printf("\nError: %.2f, \nleft motor:%i, right motor:%i\n", error, newLeftMotorVel, newRightMotorVel);
		
		leftMotor(newLeftMotorVel);
		rightMotor(newRightMotorVel);
		getHeading();
		
	}
	
	if (fixHeadingProximity(robotHeading,headingtTH) > PROXIMITY_TO_HEADING){
		turnHeadToHeading(headingtTH, speed);}
		
	motorsStop();
	
	//printf("Done Turning..");
}

int turnCorCC(double goalMinusCurrent){
	/* Takes the two headings, 0 to 360
	returns 0 if robot should go clockwise, 1 if counter-clockwise */
		
	if (goalMinusCurrent > 0){
		if (goalMinusCurrent <= 180){
			return 1;}  //Counter-Clockwise
		else{
			return 0;}  //Clockwise	
	}	
	else{
		if (goalMinusCurrent <= 180){
			return 0;}  //Clockwise
		else{
		    return 1;}//Counter-Clockwise
		
	}
	return 0; //Should never return this
}
	

double proximity_and_remainder360(double a, double b){
	//Abs value of difference
	double difference = a - b;
	if (difference < 0){
		difference = -difference;}
		
	//fix to between 0, 360
	difference = fix0to360(difference);
	return difference;
	}
	
double fixHeadingProximity(double a, double b){ //returns how close they are, irrelevent 
	double difference = a - b;
	if (difference < 0){
		difference = -1.0 * difference;}
	
	//bring to 0-360
	while (difference > 360){
		difference -= 360;
		}
	while (difference < 0){
		difference += 360;
		}
		
	//if bigger than 180, bring down
	if (difference > 180){
		difference = 360 - difference;
		}
	
	return difference;
}

double fix0to360(double thing){
	while (thing > 360){
		thing -= 360;
		}
	while (thing < 0){
		thing += 360;
		}
	return thing;
}


void getHeading(){
	
	copy_objects();
	int theta = game.coords[0].theta;
	double heading = ((double)theta * 180.0)/2047.0;
	if (heading <0){
		heading += 360;
		}
	robotHeading=heading;
	
}

void turnCt(int time, int speed){
	// Turn Clockwise for a fixed -time- , with set motor -speed-
	// Both wheels move, in opposite directions
	
	leftMotor(speed);
	rightMotor(-speed);
	
	pause(time);
	
	motorsStop();
	
}

void turnCCt(int time, int speed){
	// Turn Clockwise for a fixed -time- , with set motor -speed-
	// Both wheels move, in opposite directions
	
	leftMotor(-speed);
	rightMotor(+speed);
	
	pause(time);
	
	motorsStop();
}

void motorsStartC(int speed){ //start turning Clockwise with a given speed
	leftMotor(speed);
	rightMotor(-speed);
}

void motorsStartCC(int speed){ //start turning Clockwise with a given speed
	leftMotor(-speed);
	rightMotor(+speed);
}

void motorsStop(){
	leftMotor(0);
	rightMotor(0);
}

void spinMotorStop(){
	motor_set_vel(SPIN_MOTOR, 0);
	
}

void spinMotorRun(){
	motor_set_vel(SPIN_MOTOR, SPIN_MOTOR_SPEED);
}

void moveStraight(int time, int fwdSpeed, double moveStraightHeadingTarget){ //Heading 0 to 360
	
	//heading = fixHeading180(heading);
	
	turnHeadToHeading(moveStraightHeadingTarget,TURN_SPEED);
	
	leftMotor(fwdSpeed);
	rightMotor(fwdSpeed);
		
	int timeAtStart = get_time();
	
	double headingError;
	
	while((get_time() - timeAtStart) < time){
		getHeading();
		headingError = moveStraightHeadingTarget - robotHeading;
		
		//fix error between -179.99 and 180
		if (headingError > 180){
			headingError -= 360;}
		if (headingError <= -180){
			headingError += 360;}
		
		//If too far off, stop, and turn to heading.
		if (headingError > HEADING_TOLERANCE_BEFORE_RESET_DIR || headingError < -1.0*HEADING_TOLERANCE_BEFORE_RESET_DIR ){
			turnHeadToHeading(moveStraightHeadingTarget,TURN_SPEED);
		}
		
		else{
		double newLeftMotorVel = fwdSpeed - (headingError * HEADING_ERROR_TO_VEL_DIFF_FACTOR);
		double newRightMotorVel = fwdSpeed + (headingError * HEADING_ERROR_TO_VEL_DIFF_FACTOR);
		
		leftMotor(fixMotorVel(newLeftMotorVel));
		rightMotor(fixMotorVel(newRightMotorVel));
		}
	}
	motorsStop();
}


int fixMotorVel(double vel){
	
	if (vel < -250){
		return -250;}
	if (vel > 250){
		return 250;}
	
	if (vel<0){
		vel = -vel;
		return -1 * (int)vel;}
	return (int)vel;
		
}

int calculateTurnMotorVelFromError(double errorc){ //
	
	//Brings to range min->max, linear
	double vel = (errorc/180.0)*(TURNING_MAX_VEL - TURNING_MIN_VEL);
	
	if (errorc < 0){
		vel -= TURNING_MIN_VEL;}
	else{
		vel += TURNING_MIN_VEL;}
	
	//Deal with if exceeds maximum motor capabilities. Should never happen with reasonable Max
	if (vel < -250){
		return -250;}
	if (vel > 250){
		return 250;}
	
	//Switches to int, returns
	if (vel < 0){
		vel = -vel;
		return -1 * (int)vel;
		}
	
	return (int)vel;
		
}

double fixHeading180(double heading){  //fixes to -179.99 to +180
	heading += 720;
	while (heading > 180){
		heading -= 360; }
	return heading;
	}

double distanceFromTo(Point robot, Point goal){
	double xDiff = abs(goal.x - robot.x);
	double yDiff = abs(goal.y - robot.y);
	double distance = sqrt(xDiff*xDiff +  yDiff*yDiff);
	return distance;
}

/*
void followPoints( Point robot, Point goal){
	
	//printf("Move to Point...");
	double DesiredHeading = calculateHeading(robot, goal);
	double headingError;
	double robotHeading;
	
	turnHeadToHeading(DesiredHeading,TURN_SPEED);
	//printf("Done turning");
	leftMotor(LM_MOVE_SPEED);
	rightMotor(RM_MOVE_SPEED);
	
	
	while(true){
		
		updateRobotPosition();
		copy_objects();
		robotHeading = getHeading();
		goal.x = objects[2].x;
		goal.y = objects[2].y;
		
		//printf("\nRobot at: %i, %i, heading: %.2f", robot.x, robot.y, robotHeading);
		
		DesiredHeading = calculateHeading(robot, goal);
		headingError = DesiredHeading - robotHeading;
		
		//bring to -179 , 180
		if (headingError > 180){
			headingError -= 360;}
		if (headingError <= -180){
			headingError += 360;}
		
		//Should it go backwards???
		if (headingError > 90 || headingError < -90){
			REVERSE = 1;
			if (headingError < 90){
				headingError += 180;}
			if (headingError > 90){
				headingError -= 180;}	
		}
		else{
			REVERSE = 0;}
		
		
		//printf("%i",REVERSE);
		//printf("\nDesired heading: %.2f, error, %.2f", DesiredHeading, headingError);
		
		if (headingError > HEADING_TOLERANCE_BEFORE_RESET_DIR || headingError < -1.0*HEADING_TOLERANCE_BEFORE_RESET_DIR){
			//printf("heading too big, turning");
			turnHeadToHeading(DesiredHeading,TURN_SPEED);
		}
		
		else{
			double newLeftMotorVel = LM_FWD_SPEED - (headingError * HEADING_ERROR_TO_VEL_DIFF_FACTOR);
			double newRightMotorVel = RM_FWD_SPEED + (headingError * HEADING_ERROR_TO_VEL_DIFF_FACTOR);
			
			if (distanceFromTo(robot, goal) < 200){
				newLeftMotorVel = newLeftMotorVel/2.0;
				newRightMotorVel = newRightMotorVel/2.0;}
			
			if (REVERSE == 1){
				rightMotor(fixMotorVel(-newLeftMotorVel));
				leftMotor(fixMotorVel(-newRightMotorVel));
				
			}
			else{
				leftMotor(fixMotorVel(newLeftMotorVel));
				rightMotor(fixMotorVel(newRightMotorVel));
			}
		}
	}
}

*/


void moveToPoint(Point goal){ 
	
	updateRobot();
	
	DesiredHeading = calculateHeading(robot, goal); //Gets desired heading
	
	double headingError = DesiredHeading - robotHeading;
		
	//brings heading error to -179 , 180
	if (headingError > 180){
		headingError -= 360;}
	if (headingError <= -180){
		headingError += 360;}
	
	
	//Should it go backwards??
	if (headingError > 90 || headingError < -90 ){
		REVERSE = 1;
		if (headingError < -90){
			headingError += 180;}	
		if (headingError > 90){
			headingError -= 180;}	
		}
		
	else{
		REVERSE = 0;}
		
	if (headingError > HEADING_TOLERANCE_BEFORE_RESET_DIR || headingError < -1.0*HEADING_TOLERANCE_BEFORE_RESET_DIR){
		//printf("Move To Point, Too Far Off");
		turnHeadToHeading(DesiredHeading, TURN_SPEED);
		//printf("Move To Point, Done Turning");
		}
		
		
	double newLeftMotorVel = LM_FWD_SPEED - (headingError * HEADING_ERROR_TO_VEL_DIFF_FACTOR);
	double newRightMotorVel = RM_FWD_SPEED + (headingError * HEADING_ERROR_TO_VEL_DIFF_FACTOR);
	/*	
	//Slow down if close
	if (distanceFromTo(robot, goal) < 200){
		newLeftMotorVel = newLeftMotorVel/2.0;
		newRightMotorVel = newRightMotorVel/2.0;}
	*/
	
	//Set motor vels
	if (REVERSE == 1){
		rightMotor(fixMotorVel(-newLeftMotorVel));
		leftMotor(fixMotorVel(-newRightMotorVel));	
	}
	else{
		leftMotor(fixMotorVel(newLeftMotorVel));
		rightMotor(fixMotorVel(newRightMotorVel));
	}
	
}

void updateRobotPosition(){
	
	copy_objects();
	
	robot.x=game.coords[0].x;
	robot.y=game.coords[0].y;
}


double calculateHeading(Point robot, Point goal){ //return heading from 0 to 360
	double yDiff = goal.y - robot.y;
	double xDiff = goal.x - robot.x;
	
	double heading = atan2(yDiff, xDiff);
	heading = heading * (180.0/pi);
	if (heading < 0){
		heading += 360;
		}
	return heading;
}
	

int closerRegions(int regions[]){ //This function changes the input array with  the three closest regions to the robot. You have to pass the array as a paramater
	
	//updates array of 6, in order of closest.
	updateRobotPosition();
	double xdbl = (double)robot.x;
	double ydbl = (double)robot.y;
	
	double angFromOr = atan2(ydbl, xdbl);
	angFromOr = angFromOr * (180.0/pi);
	
	if (angFromOr < 0){
		angFromOr += 360;
		}
		
	int myRegion = getRegionFromAngle(angFromOr);
	
	regions[0] = myRegion;
	regions[1] = fix05(myRegion + 1);
	regions[2] = fix05(myRegion - 1);
	regions[3] = fix05(myRegion + 2);
	regions[4] = fix05(myRegion - 2);
	regions[5] = fix05(myRegion + 3);
	
	return 0;
}

Point convertRegionToPoints(int region){
	return centers[region];
}

int shortestPath(int myRegion,int desiredRegion){//returns 0 for anti-clockwise and 1 for clockwise

	/*
	int count_up=0, count_down=0, counter=region; 
	
	while (counter!=desiredRegion) {
		count_up++;
		if (counter==5) {
			counter=0;
		}else {
			counter++;
		}

	}
	counter=region;
	while (counter!=desiredRegion) {
		count_down++;
		if (counter==0) {
			counter=5;
		}else {
			counter--;
		}

	}
	
	if (count_up<=count_down) {
		return 0;
	}else {
		return 1;
	}
	
	return -1;
	*/
	
	
	int diff = desiredRegion - myRegion;
	if (diff < 0){
		diff += 6;}
	if (diff <= 3){
		return 0;}
	return 1;


} //tested: works but if in the opposite region it will choose one path (0) regardless of where is it exactly in the other region

void moveToRegion(int desiredRegion){ //keep calling this until you reach center of desired region
	MOVE_TIMEOUT_START = (double)get_time();
	int regions[6];
	closerRegions(regions);
	int direction = shortestPath(regions[0], desiredRegion); // 0: CCW	1: CW;
	int r;
	Point desiredPosition = convertRegionToPoints(desiredRegion);
	
	//printf("moveToRegion Called.");
	while(isInPosition(desiredPosition, PROXIMITY_TO_DESIRED_POSITION)!=1){
	
		closerRegions(regions);
		//If can go directly to point
		if (regions[0]==desiredRegion){ //if in desired region... //|| regions[1]==desiredRegion || regions[2]==desiredRegion){
			moveToPoint(convertRegionToPoints(desiredRegion));	
		}
	
		else {
		
			if (direction==1) { //Clockwise
				if (regions[0]==0){
					r = 5;}
				else {
					r = regions[0]-1;}
			}
			else { // Counter-Clockwise
				if (regions[0]==5) {
					r = 0;}
				else {
					r = regions[0] + 1;}
			}
		
		moveToPoint(convertRegionToPoints(r));
		
		if (get_time() - MOVE_TIMEOUT_START > MOVE_TIMEOUT){
			leftMotor(LM_FWD_SPEED);
			rightMotor(RM_FWD_SPEED);
			pause(750);
			leftMotor(-LM_FWD_SPEED);
			rightMotor(-RM_FWD_SPEED);
			pause(750);
			motorsStop();
			MOVE_TIMEOUT_START = (double)get_time();}
			
			
	}
	
}	
}


int decideRegion(){

	//this will include the strategy for deciding which region to go after
	
	//strategy: finds closest region with balls we can withdraw from. Thats it.
	// Add: if something further but we already control it, better to go to that? Saves time of gearbox, loses time of moving to it.
	int regions[6];
	int i;
	updateRobot();
	copy_objects();
	closerRegions(regions);
	
	
	for (i=0; i < 6; i++){
		if (game.territories[regions[i]].remaining != 0 && game.territories[regions[i]].owner!=TEAM_NUMBER && game.territories[regions[i]].rate_limit == 0){	
		//If there are balls we can get now...that we dont own...
			return regions[i];
		}		
	}
	//No regions with balls that we can take...Go for territory
	for (i=0; i < 6; i++){
		if (game.territories[regions[i]].owner!=TEAM_NUMBER){	
		//Closest thing that isnt ours that we can capture.
			return regions[i];
		}		
	}
return 0;
}
int currentRegion(){

	int regions[6];
	closerRegions(regions); 
	return regions[0];
	
}

int isInPosition(Point position, int proximity){ //returns 1 if robot is in desired position, returns 0 if not
	updateRobotPosition();
	if (distanceFromTo(robot, position)<= proximity){
		return 1;
	}else {
		return 0;
	}
}
		
	


void mockNumberTwo(){
	in_position=0;
	int reg = 0;
	reg = decideRegion();

	while (1) {
	
		if (get_time() - MASTER_START > 95000 && hasBalls != 0){
			dumpBalls(whichDumpRegion(reg));
			}
		ABANDON_GEARBOX = 0;
		updateRobot();
		copy_objects();
		
		desiredPosition = convertRegionToPoints(reg); //Decidewhich region you want to go to;
		
		if (isInPosition(desiredPosition, PROXIMITY_TO_DESIRED_POSITION)==1) { //in_position ?
			ABANDON_BING_BONG = 0;
			// At the center of the region it wants to collect from
			goTurnGearbox(reg);
			moveToRegion(reg);
			if(ABANDON_GEARBOX == 0){
				goGetBalls(reg);
				}
			if (hasBalls == DUMP_AFTER_HOW_MANY_ROUNDS){  //Has balls, ready to drop;
				dumpBalls(whichDumpRegion(reg));
			}
			reg = decideRegion();
		}
		
		else { //not in position...
			moveToRegion(reg);			
		}
	}
	
}


void dumpBalls(int r){
	updateRobot();
	
	//If not in desired Region, go to it..
	int regionss[6];
	closerRegions(regionss);
	if (regionss[0] != r){
		moveToRegion(r);
	}
	//Initialize Origin...
	Point origin;
	origin.x = 0;
	origin.y = 0;
	//Turn To Origin
	turnAssToHeading(calculateHeading(robot, origin), TURN_SPEED);
	pause(500);
	double timeStart = (double)get_time();
	while (get_time() - timeStart < WHEN_DUMP_MOVE_TO_OR_FOR){
		
		updateRobot();
		DesiredHeading = calculateHeading(robot, origin); //Gets desired heading
		
		//Get opposite heading;
		if (DesiredHeading < 180){
			DesiredHeading += 180;}
		else{
			DesiredHeading -= 180;}
		
		double headingError = DesiredHeading - robotHeading;
		
		//brings heading error to -179 , 180
		if (headingError > 180){
			headingError -= 360;}
		if (headingError <= -180){
			headingError += 360;}
		
		if (headingError > HEADING_TOLERANCE_BEFORE_RESET_DIR || headingError < -1.0*HEADING_TOLERANCE_BEFORE_RESET_DIR){
			//printf("Move To Point, Too Far Off");
			turnHeadToHeading(DesiredHeading, TURN_SPEED); //Head, because already adjusted heading, made it opposite
			//printf("Move To Point, Done Turning");
		}
		
		
		double newLeftMotorVel = -LM_FWD_SPEED - (headingError * HEADING_ERROR_TO_VEL_DIFF_FACTOR);
		double newRightMotorVel = -RM_FWD_SPEED + (headingError * HEADING_ERROR_TO_VEL_DIFF_FACTOR);
	
		leftMotor(fixMotorVel(newLeftMotorVel));
		rightMotor(fixMotorVel(newRightMotorVel));
	}
	motorsStop();
	servo_set_pos(DUMPING_SERVO,DUMPING_SERVO_OPEN);
	pause(DUMPING_PERIOD);
	/*
	for (int k = 0; k < 3; k++){
		rightMotor(150);
		leftMotor(150);
		pause(100);
		rightMotor(-150);
		leftMotor(-150);
	}
	motorsStop();
	pause(1000);
*/		
	servo_set_pos(DUMPING_SERVO,DUMPING_SERVO_CLOSED);
	hasBalls=0;
	
	leftMotor(LM_FWD_SPEED);
	rightMotor(RM_FWD_SPEED);
	pause(AFTER_DUMPING_GO_BACK_FOR);
	motorsStop();
}

void goGetBalls(int region){ //turns there and goes and gets balls.
	if (game.territories[region].owner == 18){
		GO_FOR_BING_BONG_START = (double)get_time();
		turnHeadToHeading(calculateHeading(robot, bing_bong[region]), TURN_SPEED);
		servo_set_pos(MINING_SERVO,SERVO_DEFAULT);
		while (isInPosition(bing_bong[region],PROXIMITY_TO_GEAR_BOX)!=1 && get_time() - GO_FOR_BING_BONG_START < BING_BONG_TIMEOUT) {
			moveToPoint(bing_bong[region]); //will go to the gear box in the closest region which is the region the robot in	
		}
		motorsStop();
        
		int already = game.territories[region].remaining;
        while (get_time() - GO_FOR_BING_BONG_START < BING_BONG_TIMEOUT && already - game.territories[region].remaining < 5){
			servo_set_pos(MINING_SERVO,SERVO_MINING_MAX);
			pause(SERVO_PAUSE_BETWEEN);
			servo_set_pos(MINING_SERVO,SERVO_MINING_MIN);
			pause(SERVO_PAUSE_WHILE_LEVER_DOWN);
		}
			servo_set_pos(MINING_SERVO,SERVO_DEFAULT);
			hasBalls += 1;
			pause(500);
			leftMotor(-LM_FWD_SPEED);
			rightMotor(-RM_FWD_SPEED);
			pause(AFTER_MINING_GO_BACK_FOR);
			
		}
		motorsStop();
		}
	


void updateRobot(){
	updateRobotPosition();
	getHeading();
	}

void goTurnGearbox(int region){ //turns there and goes and turns gearbox
	//printf("\n\ngo Trun Gearbox in region: %i", region);
	//pause(500);
	//Goes for the gearbox...
	updateRobot();
	GO_FOR_GEAR_START = (double)get_time();
	turnAssToHeading(calculateHeading(robot, gear_boxes[region]), TURN_SPEED);
	//start the spin motor
	spinMotorRun();
	
	while (isInPosition(gear_boxes[region],PROXIMITY_TO_GEAR_BOX)!=1 && get_time() - GO_FOR_GEAR_START < GEARBOX_TIMEOUT) {
		moveBackwardsToPoint(gear_boxes[region]); //will go to the gear box in the closest region which is the region the robot in
			
	}
	
	leftMotor(SPEED_AT_GEAR);
	rightMotor( SPEED_AT_GEAR);
	while (game.territories[region].owner != 18 && get_time() - GO_FOR_GEAR_START < GEARBOX_TIMEOUT_2){
		copy_objects();
		}
	
	spinMotorStop();
	motorsStop();
	//gearbox now turned.
}

int whichDumpRegion(int r){ //takes current region, finds closest region where it can drop from/its own city
	if (home[0] == r || home[1] == r || home[2] == r){
		return r;
	}
	else{
		if (home[0] == 0){ //Team blue
			if ( r == 3 ){return 4;}
			return 0;
		}
		else { //Team red
			if ( r == 0 ){return 1;}
			return 3;
		}
	}
}

void setupSides(){
	updateRobot();
	if (robot.x > 0){ //Team Blue...
		SPIN_MOTOR_SPEED = 255;
		home[0] = 1;
		home[1] = 2;
		home[2] = 3;
	}
	if (robot.x < 0){ //Team Red...
		SPIN_MOTOR_SPEED = -255;
		home[0] = 0;
		home[1] = 5;
		home[2] = 4;
	}
	
}
void init_centers(){
	
	centers[0].x = 1054;
	centers[0].y = 0;
	
	centers[1].x= 527;
	centers[1].y= 913;
	
	centers[2].x= -527;
	centers[2].y= 913;
	
	centers[3].x= -1054;
	centers[3].y= 0;
	
	centers[4].x= -527;
	centers[4].y= -913;
	
	centers[5].x= 527;  
	centers[5].y= -913;	
}

void init_gear_boxes(){
	
	gear_boxes[0].x=1791; //B
	gear_boxes[0].y=443;
	
	gear_boxes[1].x=512; //E
	gear_boxes[1].y=1773;
	
	gear_boxes[2].x=-1280; //H
	gear_boxes[2].y=1330;
	
	gear_boxes[3].x=-1791; //k
	gear_boxes[3].y=-443;
	
	gear_boxes[4].x=-512; //N
	gear_boxes[4].y=-1773;
	
	gear_boxes[5].x=1280; //Q
	gear_boxes[5].y=-1330;
	
	
}

void init_bing_bong_balls(){ // has the position of the ping pong balls in the field
	
	bing_bong[0].x=1791; //R
	bing_bong[0].y=-443;
	
	bing_bong[1].x=1280; //C
	bing_bong[1].y=1330;
	
	bing_bong[2].x=-512; //F
	bing_bong[2].y=1773;
	
	bing_bong[3].x=-1791; //I
	bing_bong[3].y=443;
	
	bing_bong[4].x=-1280; //L
	bing_bong[4].y=-1330;
	
	bing_bong[5].x=512; //O
	bing_bong[5].y=-1773;
	
	
}

int fix05(int n){
	if (n < 0){n += 6;}
	if (n > 5){n -= 6;}
	return n;
	}
 
 
 
void turnAssToHeading(double headingtTH, int speed){ //takes heading between 0 and 360
	//printf("\nturnAssToHeading( %f )", headingtTH);
	//get opposite heading
	if (headingtTH < 180){
		headingtTH += 180;}
	else{
		headingtTH -= 180;}
		
	//printf("\nheading fixed to: %f. Will now turn to this.", headingtTH);
	
	turnHeadToHeading(headingtTH, TURN_SPEED);
	motorsStop();
	/*
	double error;
	
	int newLeftMotorVel;
	int newRightMotorVel;
	
	//printf("\nSTART TURNING TO HEADING: %.2f\n", headingtTH);
	getHeading();
	
	while (fixHeadingProximity(robotHeading,headingtTH) > PROXIMITY_TO_HEADING){
		error = headingtTH - robotHeading;
		
		//fix error between -179.99 and 180
		if (error > 180){
			error -= 360;}
		if (error <= -180){
			error += 360;}	
		
		//Fix motor vels to ints between defined min and max rotation speeds...
		newLeftMotorVel = -calculateTurnMotorVelFromError(error);
		newRightMotorVel = calculateTurnMotorVelFromError(error);
		
		//printf("\nError: %.2f, \nleft motor:%i, right motor:%i\n", error, newLeftMotorVel, newRightMotorVel);
		
		leftMotor(newLeftMotorVel);
		rightMotor(newRightMotorVel);
		getHeading();
	}
	*/
	
}


void moveBackwardsToPoint(Point goal){ 
	
	updateRobot();
	
	DesiredHeading = calculateHeading(robot, goal); //Gets desired heading
	
	//Get opposite heading
	if (DesiredHeading < 180){
		DesiredHeading += 180;}
	else{
		DesiredHeading -= 180;}
	
	double headingError = DesiredHeading - robotHeading;
		
	//brings heading error to -179 , 180
	if (headingError > 180){
		headingError -= 360;}
	if (headingError <= -180){
		headingError += 360;}
	
	if (headingError > HEADING_TOLERANCE_BEFORE_RESET_DIR){
		pause(1000);
		turnAssToHeading(calculateHeading(robot, goal), TURN_SPEED);
		motorsStop();
		pause(1000);
		}	
		
	else {
		double newLeftMotorVel = -BACKWARD_SPEED - (headingError * BACKWARD_HEADING_ERROR_TO_VEL_DIFF_FACTOR);
		double newRightMotorVel = -BACKWARD_SPEED + (headingError * BACKWARD_HEADING_ERROR_TO_VEL_DIFF_FACTOR);
	
		//Set motor vels
		leftMotor(fixMotorVel(newLeftMotorVel));
		rightMotor(fixMotorVel(newRightMotorVel));
		}
	
	
}


double fixHeadingProximityDiffDir(double a, double b){ //returns how close they are, irrelevent 
	double difference = a - b;
	if (difference < 0){
		difference = -1.0 * difference;}
	
	//bring to 0-360
	while (difference > 360){
		difference -= 360;
		}
	while (difference < 0){
		difference += 360;
		}
		
	//if bigger than 180, bring down
	if (difference > 180){
		difference = 360 - difference;
		}
	
	return difference;
}

/*

Region 0: A (1054,0)
Region 5: P (527, -913)
Region 4: M (-527, -913)
REgion 3: J (-1054,0)
Region 2: G (-527, 913)
Region 1: D (527, 913)
Note: Regions are numberd anti-clockwise with the region with corner A as Region 1
 
 
 
 threading notes:
 
 
 */

int getRegionFromAngle(double ang){

	if (ang <= 30 || ang > 330){
		return 0;}
	if (ang <= 90){
		return 1;}
	if (ang <= 150){
		return 2;}
	if (ang <= 210){
		return 3;}
	if (ang <= 270){
		return 4;}
	if (ang <= 330){
		return 5;}
}




void rightMotor(int vel){
	motor_set_vel(RIGHT_MOTOR, vel);

}

void leftMotor(int vel){
	motor_set_vel(LEFT_MOTOR, vel);
} 




















